#!/usr/bin/php -q
<?php
// Copyright (C) 2008 - 2014 vortexbox.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// some code from LinuxMCE
//

require_once('/opt/vortexbox/amazonTools.inc.php');

function curl($url){
	$ch = curl_init();
	
	$header[0] = "Accept: text/xml,application/xml,application/xhtml+xml,";
	$header[0] .= "text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5";
//	$header[] = "Cache-Control: max-age=0";
//	$header[] = "Connection: keep-alive";
//	$header[] = "Keep-Alive: 300";
	$header[] = "Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7";
	$header[] = "Accept-Language: en-us,en;q=0.5";
	$header[] = "Pragma: "; // browsers keep this blank.

	curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/536.5 (KHTML, like Gecko) Chrome/19.0.1084.9 Safari/536.5');
	curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
//	curl_setopt($ch, CURLOPT_REFERER, 'http://www.vortexbox.org');
//	curl_setopt($ch, CURLOPT_ENCODING, 'gzip,deflate');
	curl_setopt($ch, CURLOPT_AUTOREFERER, true);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
	curl_setopt($ch, CURLOPT_TIMEOUT, 30); 
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
	
	$data = curl_exec($ch);

//	print_r(curl_getinfo($ch));

	curl_close($ch);
	return $data;
}

define('SUBID', 'AKIAICXFH6VVUKNT2Z6A');   	
define('SECRETKEY','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');              
define('AES_VERSION','2009-03-31');        	// The version of AES

$timeStamp = gmdate("Y-m-d\TH:i:s\Z");

$folders = glob('*');

$ctx = stream_context_create(array(
    'http' => array(
        'timeout' => 10
        )
    )
);
 
if(empty($argv[1])) {
	echo "CoverGrabber    Copyright (C) vortexbox.org\n";
	echo "You need to give a folder name as a command line arg.\n";
	exit;
} else {
	$folder = $argv[1];
}	
	
if(!is_dir($folder)) {
	echo "Skipping {$folder}. Not a folder?\n";
	exit;
}

if(is_file($folder."/cover.jpg")) {
	echo "Already have cover art for {$folder}.\n";
	exit;
}

// read metatags on first FLAC file in folder	
$firstflac = glob($folder."/*.flac");
if(empty($firstflac[0])) { echo "Skipping {$folder} no FLACs.\n"; exit;}

$artist = urlencode(exec("metaflac --show-tag=artist \"" . $firstflac[0]. "\" | sed 's/.*=//g'"));
$album = urlencode(exec("metaflac --show-tag=album \"". $firstflac[0]. "\" | sed 's/.*=//g'"));

if($album == "Unknown+Album") { echo "Unknown Album - No cover art to get.\n"; exit;}

echo "\nGetting cover art for {$folder} ...\n";

//------------------------------------------------------------------------------
// Make the request for cover arts using album and artist
//------------------------------------------------------------------------------

$request='Version='.AES_VERSION.'&Operation=ItemSearch&SearchIndex=Music&ResponseGroup=Medium&Sort=relevancerank&Artist='.$artist.'&Title='.$album;
// echo $request;

// START CHANGES FOR SIGNED REQUEST
// see http://docs.amazonwebservices.com/AWSECommerceService/latest/DG/index.ht... for more details

//Substitute your real Access Id here...
$request = 'Service=AWSECommerceService&AssociateTag=vort-20&'.'AWSAccessKeyId='.SUBID.'&Timestamp='.$timeStamp.'&'.$request;

// encode url - replace commas w/ %2C, replace colon w/ %3A
// Could use urlencode($request) here, but $request may already be partially encoded
$request = str_replace(',','%2C', $request);
$request = str_replace(':','%3A', $request);
$request = str_replace('+','%2B', $request);

//break request string into key/value pairs,
$reqarr = explode('&',$request);

//sort on byte value
sort($reqarr);

// tie back together w/ &'s
$string_to_sign = implode("&", $reqarr);

$string_to_sign = "GET\nwebservices.amazon.com\n/onca/xml\n".$string_to_sign;

//Substitute your real Secret Key here...
$signature = urlencode(base64_encode(hash_hmac("sha256", $string_to_sign, SECRETKEY, True)));

$request .= '&Signature='.$signature;
$request = 'http://webservices.amazon.com/onca/xml?'.$request;


// Get the response from Amazon
//print_r($request);

$xml = curl($request);

// $no_amazon takes value 2 in case no response is provided from the Amazon web service

if ($xml==false) {
	$no_amazon=2;
	echo "No response from Amazon.\n";
}
else {
	$Result = xmlparser($xml);

	if (isset($Result['ItemSearchErrorResponse']['Error'][0]['Code'])) {
		if ($Result['ItemSearchErrorResponse']['Error'][0]['Code'] == 'RequestThrottled'){
			echo "Amazon throttled for excessive usage. Try again later.\n";
			$no_amazon=2;
		}
	}

	// Check to see if we got results from amazon
	if (isset($Result['ItemSearchResponse']['Items'][0])) {
		if($Result['ItemSearchResponse']['Items'][0]['TotalResults']==0){
			$no_amazon=1;
		} else {
			$no_amazon=0;
		}
	}
	else {
		$no_amazon=2; // Error message from Amazon
	}
}

//------------------------------------------------------------------------------
// Response from Amazon was received but no exact matches. 
// Make the request for cover art using just album as keywords
//------------------------------------------------------------------------------

if($no_amazon == 1) {
	// Make the request for cover art using album 
	$request='Version='.AES_VERSION.'&Operation=ItemSearch&SearchIndex=Music&ResponseGroup=Medium&Sort=relevancerank&Keywords='.$album;

	// START CHANGES FOR SIGNED REQUEST
	// see http://docs.amazonwebservices.com/AWSECommerceService/latest/DG/index.ht... for more details

	//Substitute your real Access Id here...
	$request = 'Service=AWSECommerceService&AssociateTag=vort-20&'.'AWSAccessKeyId='.SUBID.'&Timestamp='.$timeStamp.'&'.$request;

	// encode url - replace commas w/ %2C, replace colon w/ %3A
	// Could use urlencode($request) here, but $request may already be partially encoded
	$request = str_replace(',','%2C', $request);
	$request = str_replace(':','%3A', $request);
	$request = str_replace('+','%2B', $request);

	//break request string into key/value pairs,
	$reqarr = explode('&',$request);

	//sort on byte value
	sort($reqarr);

	// tie back together w/ &'s
	$string_to_sign = implode("&", $reqarr);

	$string_to_sign = "GET\nwebservices.amazon.com\n/onca/xml\n".$string_to_sign;

	//Substitute your real Secret Key here...
	$signature = urlencode(base64_encode(hash_hmac("sha256", $string_to_sign, SECRETKEY, True)));

	$request .= '&Signature='.$signature;
	$request = 'http://webservices.amazon.com/onca/xml?'.$request;

	//echo $request;

	// Get the response from Amazon
	$xml = curl($request);

	if ($xml==false) {
		$no_amazon=2;
	}
	else {
		// Parse the results
		$Result = xmlparser($xml);
		if (isset($Result['ItemSearchErrorResponse']['Error'][0]['Code'])) {
			if ($Result['ItemSearchErrorResponse']['Error'][0]['Code'] == 'RequestThrottled'){
				echo "Amazon throttled for excessive usage. Try again later.\n";
				$no_amazon=2;
			}
		}

		 // Check to see if we got results from amazon
        	if (isset($Result['ItemSearchResponse']['Items'][0])) {
                	if($Result['ItemSearchResponse']['Items'][0]['TotalResults']==0){
                        	$no_amazon=1;
                	} else {
                        	$no_amazon=0;
                	}
        	}
        	else {
                	$no_amazon=2; // Error message from Amazon
        	}
	}
}

//------------------------------------------------------------------------------
// Album art was found on Amazon
//------------------------------------------------------------------------------

if($no_amazon == 0) {
        $found=0;
        foreach ($Result['ItemSearchResponse']['Items'][0]['Item'] as $item) {
                $found++;
                if (isset($item['LargeImage']['URL'])) {
                        // grab the cover art if exist, download it and save the record in database
			if(!is_file($folder."/cover.jpg")) {
 				echo "Found cover art on Amazon.\n";
                        	savePic($item['LargeImage']['URL'],$folder.'/cover.jpg');
				break;
                        }
                }
        }
}



//------------------------------------------------------------------------------
// No album art was found on Amazon or Amazon response was empty. 
// Trying Google Images
//------------------------------------------------------------------------------

if ($no_amazon == 2){

 	echo "No cover art found on Amazon.com, trying Google Images.\n";

	$q_artist = urldecode($artist);
	$q_album = urldecode($album);

	$query = '"' . $q_artist . '" ' . $q_album;
	$manual_referer = 'http://vortexbox.org/';
	
	// See reference for how to modify search
	// http://code.google.com/apis/ajaxsearch/documentation/reference.html
	$args = array(
    		'v' => '1.0',
    		'q' => $query,
    		'as_filetype' => 'jpg',
		'hl' => 'en-us',
		'imgsz' => 'medium',
    		'safe' => 'active', // image "safeness"
	);
	$url = "http://ajax.googleapis.com/ajax/services/search/images?";
	foreach ($args as $key => $val) {
    		$url .= $key . '=' . rawurlencode($val) . '&';
	}

	$body = curl($url);

	if ($body==false) {
		echo 'Response from Google Images failed. Exiting';
		exit(1);
	}

	$json = json_decode($body, true);

	if (isset($json['responseData']['results'][0])) {	
		$image = $json['responseData']['results'][0];

 		// grab the cover art if exist, download it and save in the folder

        	echo "Found cover art on Google Images\n";
		savePic($image['url'],$folder.'/cover.jpg');
	}
	else {
		echo "No cover art found on Google Images\n";
	}
}        

echo "Done getting cover art for {$folder}\n\n";

function savePic($url,$path){
	// remove \n from url
	$url=str_replace("\n",'',$url);
	
	// copy the pic localy if the param is specified
	// path need to be a working path with write permission
	if($path!=''){
		if(file_exists($path)){
			$cmd='sudo -u root rm -f "'.$path.'"';
			exec($cmd);
		}
		$getPicCmd='wget --no-dns-cache --retry-connrefused --random-wait --header=\'User-Agent: Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/536.5 (KHTML, like Gecko) Chrome/19.0.1084.9 Safari/536.5\' -O - \''.$url.'\' > "'.$path.'"';
		$coverArtPage=exec($getPicCmd);
	}
}
?>
