#!/usr/bin/php
<?php
// Copyright (C) 2008 - 2012 vortexbox.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

error_reporting(E_ERROR);

$configfile = "/var/www/html/config/dlna.cfg";
$deftemplate = "/var/www/html/config/minidlna.conf.template";
$minidlnaconf = "/var/tmp/minidlna.conf";

include '/var/www/html/libs/SearchReplace.php' ;

$config = array();

if(empty($argv[1])) {
	echo "\n";
	echo "DLNA Manager                     Copyright (C) vortexbox.org\n";
	echo "-a Audio files location\n";
	echo "-v Video files location\n";
	echo "-p Picture files location\n";
	echo "-d Description\n";
	echo "-s Art size in px\n";	
	echo "\n";
	exit;
}

//loop through our arguments and see what the user selected
   for ($i = 1; $i < $_SERVER["argc"]; $i++)
   {
       switch($_SERVER["argv"][$i])
       {
       
           case "-a":
               $config['AUDIOFILES'] = $_SERVER["argv"][++$i];
               break;
           case "-v":
               $config['VIDEOFILES'] = $_SERVER["argv"][++$i];
               break;
           case "-p":
               $config['PICTUREFILES'] = $_SERVER["argv"][++$i];
               break;
           case "-d":
               $config['DESCRIPTION'] = $_SERVER["argv"][++$i];
               break;
           case "-s":
               $config['ARTSIZE'] ==intval($_SERVER["argv"][++$i]);
               break;			   

       }
   } 

if (!isset($config['AUDIOFILES'])) { $config['AUDIOFILES'] = "/storage/music/mp3"; }
if (!isset($config['VIDEOFILES'])) { $config['VIDEOFILES'] = "/storage/movies"; }
if (!isset($config['PICTUREFILES'])) { $config['PICTUREFILES'] = "/storage/pictures"; }
if (!isset($config['DESCRIPTION'])) { $config['DESCRIPTION'] = "VortexBox media server"; }
if (!isset($config['ARTSIZE'])) { $config['ARTSIZE'] = intval("140"); }
if ($config['ARTSIZE'] > 640) {$config['ARTSIZE'] = "640"; }

$fp = fopen($configfile,'w');
fwrite($fp,serialize($config));
fclose($fp);
		
$files_to_search = array($minidlnaconf);
$search_string  = array('##AUDIOFILES##', '##VIDEOFILES##', '##PICTUREFILES##','##DESCRIPTION##', '##ARTSIZE##');
$replace_string = array($config['AUDIOFILES'], $config['VIDEOFILES'], $config['PICTUREFILES'], $config['DESCRIPTION'], $config['ARTSIZE']);

copy($deftemplate, $minidlnaconf);
 
$snr = new File_SearchReplace($search_string,
    $replace_string,
    $files_to_search,
    $direc_to_search,
    true) ;
$snr->doSearch();

echo "Restarting MiniDLNA with new settings...\n";
		
exec("sudo /opt/vortexbox/doaction.sh RestartDLNA & >/dev/null 2>&1");

echo "Done\n";

?>
