#!/bin/sh
# Copyright (C) 2008 - 2012 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

function echolog {
echo "`date +'%m/%d/%Y %H:%M:%S'` - $1"
}

echolog "Backing up /storage to $USBDISK." >> /var/log/usbbackup.log
rsync -rt -v --delete --force /storage/ /backup/storage/ >> /var/log/usbbackup.log
echo "`date +'%m/%d/%Y %H:%M:%S'`" > /backup/.lastbackup
echolog "Backup finished." >> /var/log/usbbackup.log
sync
umount /backup -l
STATUS=$?
if test $STATUS -eq 0
then
	echolog "You can now safely disconnect your USB drive." >> /var/log/usbbackup.log
else
	echolog "Error $STATUS occured while unmounting USB drive. Please reboot." >> /var/log/usbbackup.log
fi