#!/bin/sh
# Copyright (C) 2008 - 2012 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# Restore missing files in /storage from USB Backup drive.
#
# Changelog:
#
# Thurs Jun 23 2011 Ron Olsen <ronolsen@comcast.net>
# * Initial version.  Based on code from Steve Gray <amawalk@gmail.com>

function echolog {
echo "`date +'%m/%d/%Y %H:%M:%S'` - $1"
}

echolog "Restore (Add missing files) from USB drive to /storage" >> /var/log/usbbackup.log
touch /etc/vortexbox/restore.running
rsync -av --ignore-existing /backup/storage/ /storage/ >> /var/log/usbbackup.log
echo "`date +'%m/%d/%Y %H:%M:%S'`" > /backup/.lastrestore
echolog "Restore (Add missing files) finished." >> /var/log/usbbackup.log
rm -f /etc/vortexbox/restore.running
sync
umount /backup

