#!/bin/sh
# Copyright (C) 2008 - 2012 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

function echolog {
echo "`date +'%m/%d/%Y %H:%M:%S'` - $1"
}

echo "" >> /var/log/vbupgrade.log
echolog "Installing Plex Media Server (This can take a long time...)" >> /var/log/vbupgrade.log

yum clean all
rm -rf /var/cache/yum/*
rm -rf /var/lib/yum/yumdb/*
yum -y install plexmediaserver lame flac faad2 vorbis-tools ffmpeg mplayer mac faac --skip-broken >> /var/log/vbupgrade.log

if [ ! -d /usr/lib/win32 ]; then
  mkdir -p /usr/lib/win32
  cd /var/tmp
  wget http://www1.mplayerhq.hu/MPlayer/releases/codecs/essential-20071007.tar.bz2
  bzip2 -cd essential-20071007.tar.bz2 | tar xvf -
  rm essential-20071007.tar.bz2
  cp essential-20071007/* /usr/lib/win32
  rm -rf essential-20071007
fi

touch /etc/vortexbox/packages/plex

/bin/systemctl enable plexmediaserver.service
/bin/systemctl start plexmediaserver.service

echolog "Plex Media Server installed." >> /var/log/vbupgrade.log
echo "" >> /var/log/vbupgrade.log
