#!/bin/bash
# Copyright (C) 2008 - 2014 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

if [ -f /opt/vortexbox/fix_audio.sh ]
 then
	sh /opt/vortexbox/fix_audio.sh 
fi

if [ ! -f /etc/vortexbox/nounmute ]
 then
	for i in {1..4}
	do
		/usr/bin/amixer set Master 100% unmute --card=$i >/dev/null 2>&1
		/usr/bin/amixer set Front 100% unmute --card=$i >/dev/null 2>&1
		/usr/bin/amixer set PCM 100% unmute --card=$i >/dev/null 2>&1
		/usr/bin/amixer set Headphone 100% unmute --card=$i >/dev/null 2>&1

		/usr/bin/amixer set Surround 100% unmute --card=$i >/dev/null 2>&1
		/usr/bin/amixer set Side 100% unmute --card=$i >/dev/null 2>&1
		/usr/bin/amixer set Center 100% unmute --card=$i >/dev/null 2>&1
		/usr/bin/amixer set LFE 100% unmute --card=$i >/dev/null 2>&1
		
		/usr/bin/amixer set 'IEC958' unmute --card=$i >/dev/null 2>&1
		/usr/bin/amixer set 'IEC958',1 unmute --card=$i >/dev/null 2>&1

		/usr/bin/amixer set Speaker 100% unmute --card=$i >/dev/null 2>&1
		/usr/bin/amixer sset "Auto Gain Control" off --card=$i  >/dev/null 2>&1
		/usr/bin/amixer sset "Loudness" off --card=$i >/dev/null 2>&1
		
		# Unmute fix for XMOS DACs
		/opt/vortexbox/xmos_set.php $i
		
		# Unmute fix for Lindemann Musicbook 10/15 (XMOS with strange names)
		/usr/bin/amixer set 'iAP Interface',0 127 unmute 100% --card=$i >/dev/null 2>&1
		/usr/bin/amixer set 'iAP Interface',1 127 unmute 100% --card=$i >/dev/null 2>&1

		# Unmute fix for a few more DACs that are tough to unmute
	
		# Unmute all playback channels
		for x in `amixer controls -c $i | grep -i "Playback Swi"` ; do amixer cset "${x}" on > /dev/null 2>&1 ; done
 
		# Set volume on all channels to 100%
		for x in `amixer controls -c $i | grep -i "Playback Vol"` ; do amixer cset "${x}" 100% > /dev/null 2>&1 ; done
	
	done
fi

/sbin/alsactl store