#!/bin/sh
# Copyright (C) 2008 - 2015 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# Changelog:
#
# Sat Jun 25 2011 Ron Olsen <ronolsen@comcast.net>
# * Don't fix permissions; this is already done on reboot in vb-startup.
# * Don't check for obsolete packages.
# * Only install minidlna and forked-daapd if they are not already installed.
# * Only start httpd if it is not already running.

# Remove old atrpms repo
rpm -e --nodeps atrpms-repo

# Remove old Fedora repo
sed -i -e 's/^enabled=1/enabled=0/' /etc/yum.repos.d/fedora*

# Fix packages that cause problems
rpm -e --nodeps libva1 libva-x11_1
yum -y install libva
rpm -e --nodeps fprintd fprintd-pam
rpm -e --nodeps libswresample0 libswscale2  libpostproc52  ffmpeg  libavfilter2 libavdevice53
yum -y --enablerepo=vortexboxbeta --exclude=plexmediaserver install ffmpeg

# Make sure ushare is removed
service ushare stop
rpm -e vb-ushare

# make sure forked-daapd is removed
service mt-daapd stop
service forked-daapd stop
rpm -e vb-mt-daapd
if [ -f /usr/sbin/forked-daapd ]
then
    yum -y erase forked-daapd
	rm -rf /usr/lib/forked-daapd
	rm -rf /var/cache/forked-daapd
	rm -rf /var/log/forked-daapd.log
fi

# start httpd if it has been stopped during the upgrade
if echo $(service httpd status) | grep "is running" > /dev/null 
then
    #echo "httpd is running"
    continue
else
    #echo "httpd not running; restart httpd"
    service httpd start
fi
