#!/bin/sh
# Copyright (C) 2012-2013 Doug Asherman
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# 08/12/12 Clean up display, echo to main mirror log
# 04/08/13 Remove hardcoded output file redirects
# 04/09/13 Don't call metaflac. The results look neat, but it's a waste of time

foo=`pwd`
# whether or not to test for newer file
testage=0


function echolog {
echo "`date +'%m/%d/%Y %H:%M:%S'` - $1"
}

oggdir=${foo/flac/ogg}
# if the oggdir exists, then we should compare the ogg and flac files
# (it's assumed that the ogg file exists if the ogg dir exists)
# if the oggdir doesn't exist, then make it
if [ -a $oggdir ]; then
        testage=1
else
	mkdir -p $oggdir
fi

if [ -f /etc/vortexbox/oggopt ]; then
	oggquality=`cat /etc/vortexbox/oggopt`
else
	oggquality='--quality=10'
fi

echolog "Starting encoding in $oggdir"
# so, if testage == 1 then that means the ogg mirror dir exists
# (now say ogg mirror dir three times fast) so we check to see if
# the flac file is newer than the ogg file. if it is, we re-encode
#
# otherwise, should log it somehow (or not, I don't know)
for i in $( ls *.flac ); do
        oggbasefile=${i/flac/ogg}
	oggfile=$oggdir/${i/flac/ogg}
        if ((testage == 1)); then
		if [ $oggfile -nt $i ]; then
			continue;
		fi
	fi
        echolog "Encoding $i"
	( exec oggenc $oggquality --output=$oggfile $i 2> /dev/null )
done
	if [ -f cover.jpg ]; then
		rsync -u --perms cover.jpg $oggdir
	fi
echolog "Ending encoding in $oggdir"

