#!/bin/bash
# Copyright (C) 2008 - 2013 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

if [ $# -ne 1 ]
then
    echo "Usage: image2iso imagefile"
    exit 1
fi

# Path to dvdauthor binary
DVDAUTHOR="$(which dvdauthor)"

# Path to mkisofs binary
MKISOFS="$(which mkisofs)"

# Check that we have all the required binaries

yum clean all

if [ ! -x "$DVDAUTHOR" ]; then
  echo "ERROR: dvdauthor not installed installing..." >&2
  yum -y  install dvdauthor --skip-broken
fi

if [ ! -x "$MKISOFS" ]; then
  echo "ERROR: mkisofs not installed installing..." >&2
  yum -y  install mkisofs --skip-broken
fi

NAME=${1%.*}

rm -rf /var/tmp/image2iso
mkdir /var/tmp/image2iso

echo ""
echo "Converting $1 to $NAME.iso..."
echo ""
ffmpeg -i  "$1" -fs 4200000000 -vcodec mpeg2video -acodec copy -target ntsc-dvd /var/tmp/image2iso/temp.mpg

cd /var/tmp/image2iso
dvdauthor -t -o DVD -f ./temp.mpg
dvdauthor -T -o DVD
cd ..
mkisofs -dvd-video -udf -o "$NAME.iso" image2iso/DVD

rm -rf /var/tmp/image2iso

echo ""
echo "$NAME.iso Done."
echo ""