#!/bin/bash
# Copyright (C) 2008 - 2013 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

sed -i 's/# GOTO=/GOTO=/g' /lib/udev/rules.d/71-biosdevname.rules

sed -i '/DHCP_HOSTNAME/ d'  /etc/sysconfig/network-scripts/ifcfg-eth0
/etc/init.d/network reload > /dev/null 2>&1

if ! grep "^PS1" /etc/profile >/dev/null 2>&1; then
	echo 'PS1="[\H \W]# "' >> /etc/profile
fi

# auto reboot if there is a kernel panic
if ! grep "panic" /etc/sysctl.conf >/dev/null 2>&1; then
	echo "kernel.panic=5" >> /etc/sysctl.conf
fi

mkdir -p /storage/music/flac
mkdir -p /storage/music/mp3
mkdir -p /storage/music/playlist
mkdir -p /storage/pictures
mkdir -p /storage/movies

chown -R squeezeboxserver:squeezeboxserver /storage/music/playlist

service squeezeboxserver stop
sleep 3

echo "ignoreInImageScan:" >> /etc/squeezeboxserver/server.conf
echo "- /storage/music/flac" >> /etc/squeezeboxserver/server.conf
echo "ignoreInVideoScan:" >> /etc/squeezeboxserver/server.conf
echo "- /storage/music/flac" >> /etc/squeezeboxserver/server.conf
echo "mediadirs:" >> /etc/squeezeboxserver/server.conf
echo "- /storage/music/flac" >> /etc/squeezeboxserver/server.conf
echo "mDNSname:" >> /etc/squeezeboxserver/server.conf
echo "playlistdir: /storage/music/playlist" >> /etc/squeezeboxserver/server.conf
echo "wizardDone: 1" >> /etc/squeezeboxserver/server.conf
