#!/bin/bash
# Copyright (C) 2008 - 2013 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

echo "-------------------------------------------"
echo "Configure Services"
echo "-------------------------------------------"

/bin/systemctl enable NetworkManager-wait-online.service

# Setup ntp time service
/bin/systemctl stop ntpdate.service
sleep 2
echo "driftfile /var/lib/ntp/drift" > /etc/ntp.conf
echo "server 0.pool.ntp.org" >> /etc/ntp.conf
echo "server 1.pool.ntp.org" >> /etc/ntp.conf
echo "server 2.pool.ntp.org" >> /etc/ntp.conf
echo "server 127.127.1.0" >> /etc/ntp.conf
echo "fudge 127.127.1.0 stratum 10" >> /etc/ntp.conf
/usr/sbin/ntpdate pool.ntp.org

# Remove unused services
/bin/systemctl disable cups.service
/bin/systemctl disable bluetooth.service
/bin/systemctl disable iptables.service
/bin/systemctl disable ip6tables.service
/bin/systemctl disable pcscd.service

# Add required services
cp /var/vortexbox_load/smb.conf /etc/samba/smb.conf

cp /var/vortexbox_load/http.service /etc/avahi/services/
cp /var/vortexbox_load/slimhttp.service /etc/avahi/services/

cp /var/vortexbox_load/rsyncd.conf /etc/rsyncd.conf

echo "/storage *(ro)" > /etc/exports
/bin/systemctl enable nfs-server.service
exportfs -a

/bin/systemctl enable ntpdate.service
/bin/systemctl enable ntpd.service
/bin/systemctl enable httpd.service
/bin/systemctl enable nfs-server.service
/bin/systemctl enable smb.service
/bin/systemctl enable nmb.service
/bin/systemctl enable httpd.service

chkconfig --add vortexbox
chkconfig rsync on
 